YACC(1)

NAME
yacc - an LALR(1) parser generator

SYNOPSIS
yacc [-dgilPrtVv] [-b prefix] [-o outputfile] [-p symbol_prefix] filename

DESCRIPTION
yacc reads the grammar specification in the file filename and generates an LALR(1) parser for it. The parsers consist of a set of LALR(1) parsing tables and a driver routine written in the C programming language. yacc normally writes the parse tables and the driver routine to the file y.tab.c.

The following options are available:

-b prefix
    The -b option changes the prefix prepended to the output file names to the string denoted by prefix. The default prefix is the character y.

-d  The -d option causes the header file y.tab.h to be written. It contains #define's for the token identifiers.

-g  The -g option causes a graphical description of the generated LALR(1) parser to be written to the file y.dot in graphviz format, ready to be processed by dot(1).

-i  The -i option causes a supplementary header file y.tab.i to be written. It contains extern declarations and supplementary #define's as needed to map the conventional yacc yy-prefixed names to whatever the -p option may specify. The code file, e.g., y.tab.c is modified to #include this file as well as the y.tab.h file, enforcing consistent usage of the symbols defined in those files. The supplementary header file makes it simpler to separate compilation of lex- and yacc-files.

-l  If the -l option is not specified, yacc will insert #line directives in the generated code. The #line directives let the C compiler relate errors in the generated code to the user's original code. If the -l option is specified, yacc will not insert the #line directives. #line directives specified by the user will be retained.

-o outputfile
    The -o option specifies an explicit output file name should be used instead of the default.

-P  The -P options instructs yacc to create a reentrant parser, like “%pure-parser” does.

-p symbol_prefix
    The -p option changes the prefix prepended to yacc-generated symbols to the string denoted by symbol_prefix. The default prefix is the string yy.

-r  The -r option causes yacc to produce separate files for code and tables. The code file is named y.code.c, and the tables file is named y.tab.c.

-t  The -t option changes the preprocessor directives generated by yacc so that debugging statements will be incorporated in the compiled code.

-V  The -V option prints the version number to the standard output.

-v  The -v option causes a human-readable description of the generated parser to be written to the file y.output.

EXTENSIONS
yacc provides some extensions for compatibility with bison(1) and other implementations of yacc:

%expect number
    Tell yacc the expected number of shift/reduce conflicts. That makes it only report the number if it differs.
%expect-rr number
    Tell yacc the expected number of reduce/reduce conflicts. That makes it only report the number if it differs. This is (unlike bison(1)) allowable in LALR(1) parsers.
%lex-param { argument-declaration }
    By default, the lexer accepts no parameters, e.g., yylex(). Use this directive to add parameter declarations for your customized lexer.
%parse-param { argument-declaration }
    By default, the parser accepts no parameters, e.g., yyparse(). Use this directive to add parameter declarations for your customized parser.
%pure-parser
    Most variables (other than yydebug and yynerrs) are allocated on the stack within yyparse(), making the parser reasonably reentrant.

ENVIRONMENT
The following environment variable is referenced by yacc:

TMPDIR
    If the environment variable TMPDIR is set, the string denoted by TMPDIR will be used as the name of the directory where the temporary files are created.

TABLES
The names of the tables generated by this version of yacc are “yylhs”, “yylen”, “yydefred”, “yydgoto”, “yysindex”, “yyrindex”, “yygindex”, “yytable”, and “yycheck”. Two additional tables, “yyname” and “yyrule”, are created if YYDEBUG is defined and non-zero.

FILES
y.code.c
y.tab.c
y.tab.h
y.output
/tmp/yacc.aXXXXXX
/tmp/yacc.tXXXXXX
/tmp/yacc.uXXXXXX

DIAGNOSTICS
If there are rules that are never reduced, the number of such rules is written to the standard error. If there are any LALR(1) conflicts, the number of conflicts is also written to the standard error.

STANDARDS
The yacc utility conforms to p1003.2.